%centroids4.m
%This function should find the centroids of the B&W image that is input
%NOTE: Added error check for incorrect # of centroids
%   -added detection and recording of data squares 
function C = centroids4(A,b)
%Find all blobs and label
A=bwlabel(A);
%Initial conditions
k=1;
B=zeros(max(A(:)),6);
[i,j]=size(A);
found=zeros(1,b+3);

%Scan for labeled blobs
for t=1:j
    for s=1:i
        if A(s,t)~=0
            B(A(s,t),4)=B(A(s,t),4)+1;      %Num of pixels in each centroid
            B(A(s,t),5)=B(A(s,t),5)+s;      %Sum of row values of centroid
            B(A(s,t),6)=B(A(s,t),6)+t;      %Sum of col values of centroid
            found(1,A(s,t))=1;              %Marker for the blob # found
            found(1,5)=1;                   %Marker for found centroid in this column or row
        end
    end
    %Quick exit after b centroids have been found and a blank column or row
    if ((sum(found(1:4))==b+2)&(found(5)==0))
        fprintf('-');
        C=ccent4(B,max(A(:)));
        if max(C(:,1))~=b
            C=zeros(max(C(:,1)),1);
        end
        return 
    end
    found(5)=0;
end

%Find centroid center
C=ccent4(B,max(A(:)));
if max(C(:,1))~=b
    C=zeros(max(C(:,1)),1);
end
