%PROCAVI.M This function will load an 'avi' file and process the movie to
%   determine the angle of the body
%   -added detection and recording of data squares 

function [beta, bdata]=procavi(fname)

thresh=0.4;
%load the *.avi movie
if nargin<1
    [fname,fpath]=uigetfile('*.avi','Select UNCOMPRESSED ''avi''');
end
fprintf(['Loading ''' fname ''' ... '])
eval(['mdata=aviread(''' fname ''');'])
fprintf('done.\n')
ldata=length(mdata);
%convert movie to image
fprintf('Processing:\n')
for i=1:ldata
    fprintf(['Frame #:' num2str(i,'%03d') '\n'])
    fdata(:,:,i)=frame2im(mdata(i));
    %process images
    fdata(:,:,i)=im2bw(fdata(:,:,i),thresh);
    tdata=centroids4(fdata(:,:,i),2);
    %Get centroids3 to do ALL the following
    N=size(tdata,1);    
%    cdata=[tdata(1,2:3) tdata(2,2:3)];
    if N==2
        cdata=[tdata(1,2:3) tdata(2,2:3)];
        beta(i)=180/pi*atan2(cdata(1)-cdata(3),cdata(2)-cdata(4));
        bdata(i,1:2)=tdata(1,4:5);
        if (bdata(i,2)~=0)&(i<249)
            bdata(i+4,3)=1;         %Add signal for 2nd tripod (approximate for 133ms period)
        end
    else 
        if N>2
            fprintf([' NOTE: 2+ blobs found (' num2str(N) ').\n'])
        end
        if N<2
            fprintf([' NOTE: Less than 2 blobs found (' num2str(N) ').\n'])
        end
    end
end
beta=unwrap(beta,180);

clear fname fpath mdata ldata i N cdata